diff --git a/modules/stream_out/transcode/audio.c b/modules/stream_out/transcode/audio.c
index f54aa5f..a60e7a0 100644
--- a/modules/stream_out/transcode/audio.c
+++ b/modules/stream_out/transcode/audio.c
@@ -104,6 +104,22 @@ static int transcode_audio_filter_chain_build( sout_stream_t *p_stream, filter_c
          p_src->audio.i_rate,
          p_dst->audio.i_rate );
 
+    /* If codec is mpga, convert to fi32 */
+    if( current.i_codec == VLC_CODEC_MPGA ||
+        current.i_codec == VLC_FOURCC('m','p','g','3') )
+    {
+        current.i_codec =
+        current.audio.i_format = VLC_CODEC_FI32;
+        aout_FormatPrepare( &current.audio );
+
+        if( !filter_chain_AppendFilter( p_chain, NULL, NULL, NULL, &current ) )
+        {
+            msg_Err( p_stream, "Failed to find conversion filter to fi32" );
+            return VLC_EGENERIC;
+        }
+        current = *filter_chain_GetFmtOut( p_chain );
+    }
+
     /* If any filter is needed, convert to fl32 */
     if( current.i_codec != VLC_CODEC_FL32 )
     {
